#include <JGL/types/Light.h>
#include <glad/glad.h>

JGL::Light::Light(const Vector3& position, const Color4& ambient, const Color4& diffuse, const Color4& specular) {
    this->position = Vector4(position, 1.0f);
    this->ambient = ambient;
    this->diffuse = diffuse;
    this->specular = specular;
}

Vector3 JGL::Light::GetNormalizedSceenSpaceCoordinates() const {
    GLint viewport[4];
    glGetIntegerv(GL_VIEWPORT, viewport);

    float normalized_x = 2.0f * (position.x - viewport[0]) / viewport[2] - 1.0f;
    float normalized_y = 2.0f * (position.y - viewport[1]) / viewport[3] - 1.0f;

    return {normalized_x, normalized_y, position.z};
}
